#!/usr/bin/python3

import sys


def proc(lines):
    lines = [l for l in lines if l]
    if "tag" in lines[0]:
        tag = lines[0].split()[-1].strip(')')
        print("--------------------------- tag:", tag)

    merged = False
    for line in lines[1:]:
        if "Merge pull request #" in line:
            merged = True
            continue
        if merged:
            print(line)

useful = []
for line in sys.stdin:
    line = line.strip()

    if line.startswith("commit"):
        if useful:
            proc(useful)
        useful = [line]
    else:
        useful.append(line)
if useful:
    proc(useful)
